#!/usr/bin/perl

use CGI qw/:standard/;

sub dorv {
	my $host = shift;
	my $assid = shift;
	$cmd = "ntpq -c 'rv $assid' $host";
	print em($cmd);
		chomp;
	open (RV, "ntpq.dns -c 'rv $assid' $host |");

	@imglnk;

	print "\n<pre><table border=1>\n";
	while (<RV>) {
		chomp;
		@rv = split(/=/, $_);
		if ( $rv[0] =~ /^filt(delay|offset|disp)$/ ) {
			$name = substr($rv[0], 4);
			$data = join('_', split(/ +/, $rv[1]));
			# $rv[0] = a({href=>"dorv.pl?data=$data&name=$name"}, $rv[0]);
			push (@imglnk, "dorv.pl?data=$data&name=$name");
		}
		$ll = td({-align=>LEFT}, [$rv[0]]);
		$lr = td({-align=>RIGHT}, [$rv[1]]);
		print Tr(["$ll $lr"]);
		print "\n";
	}
	print "\n</table></pre>\n";
	# print img(-name=>'delay');
	print "<img src='$imglnk[0]'>";
	print "<img src='$imglnk[1]'>";
	print "<img src='$imglnk[2]'>";
}

print header;
print start_html('ntpq.pl');
# print h1('Perl interface to ntpq');

print start_form;
print b('hostname '), textfield('hostname'), hr;
print end_form;

if (param()) {
	$host = param('hostname');
	$assid = param('assid');
	if ($host !~ /^([a-zA-Z0-9-]+\.)*[a-zA-Z0-9]+$/) { 
		print b('bad hostname '), em($host);
		print end_html;
		exit;
	}
	if (length($assid) > 0) {
		if ($assid !~ /^[1-9][0-9]+$/) {
			print b('bad assid '), em($assid);
			print end_html;
			exit;
		} else {
			dorv ($host, $assid);
			print end_html;
			exit;
		}
	}


	@keys[3..10] = qw/3 0 5 6 7 8 9 10/;

	print b('command:');
	print '<br>';
	print em('ntpq -p', $host);
	
	$key = param('key');
	if ( $key =~ /^[-]{0,1}[356789]|(10)$/ ) {
		$keys[$key] = 0 - "$key";
		if ( $key < 0 ) {
			$rev = "-r";
		}
		$key = abs($key);
		open(NTPQ, "ntpq.dns -p $host | sort -g -k $key $rev|");
	} else {
		open(NTPQ, "ntpq.dns -p $host |");
	}
	
	$line = 0;
	$ref = url();

	print "\n<pre><table border=1>\n";

	print	Tr({-align=>CENTER,-valign=>TOP},
			[
			th([	'tally',
				'remote',
				'refid',
				a({href=>"$ref?hostname=$host&key=$keys[3]"}, 'st'),
				't',
				a({href=>"$ref?hostname=$host&key=$keys[5]"}, 'when'),
			    	a({href=>"$ref?hostname=$host&key=$keys[6]"}, 'poll'),
				a({href=>"$ref?hostname=$host&key=$keys[7]"}, 'reach'),
				a({href=>"$ref?hostname=$host&key=$keys[8]"}, 'delay'),
				a({href=>"$ref?hostname=$host&key=$keys[9]"}, 'offset'),
				a({href=>"$ref?hostname=$host&key=$keys[10]"}, 'jitter')
				])
			]
		);

	while (<NTPQ>) {
		chomp;
		$status = substr($_, 0, 1);
		@peer = split;
		$associd = pop(@peer);

		$tally = 'unknown';
		if ($status =~ / /) { $tally = 'reject'; }
		if ($status =~ /x/) { $tally = 'falsetick'; }
		if ($status =~ /\./) { $tally = 'excess'; }
		if ($status =~ /\-/) { $tally = 'outlayer'; }
		if ($status =~ /\+/) { $tally = 'candidat'; }
		if ($status =~ /#/) { $tally = 'selected'; }
		if ($status =~ /\*/) { $tally = 'sys.peer'; }
		if ($status =~ /o/) { $tally = 'pps.peer'; }
		$status = b($status);
		$asshref = a({href=>"$ref?hostname=$host&assid=$associd"}, $tally);
		$tally = "$status $asshref";

		$s1 = shift @peer;
		if ($status !~ / /) {
			$s1 = substr($s1, 1);
		}

		if ($s1 =~ /^REFCLK\([1-9][0-9]*,[0-9]*,[A-Z_]*\)$/ ) {
			chop($s1);
			$brace = substr($s1, 7);
			@refclk = split(/,/, $brace);
			$a1 = a({href=>"http://www.eecis.udel.edu/~mills/ntp/html/drivers/driver$refclk[0].html"}, "$refclk[2]($refclk[1])");
		} else {
			$a1 = a({href=>"$ref?hostname=$s1"}, $s1);
		}

		$s2 = shift @peer;
		# $a2 = a({href=>"$ref?hostname=$s2"}, $s2);
		if ($s2 =~ /^REFCLK\([1-9][0-9]*,[0-9]*,[A-Z_]*\)$/ ) {
			chop($s2);
			$brace = substr($s2, 7);
			@refclk = split(/,/, $brace);
			$a2 = a({href=>"http://www.eecis.udel.edu/~mills/ntp/html/drivers/driver$refclk[0].html"}, "$refclk[2]($refclk[1])");
		} elsif ($s2 =~ /^\.[a-zA-Z_]+\.$/ ) {
			$a2 = $s2;
		} elsif ($s2 =~ /^0\.0\.0\.0$/ ) {
			$a2 = $s2;
		} else {
			$a2 = a({href=>"$ref?hostname=$s2"}, $s2);
		}

		$ll = td({-align=>LEFT}, [$tally, $a1, $a2]);
		$lr = td({-align=>RIGHT}, [@peer]);
		print Tr(["$ll $lr"]);

		print "\n";
	}
	print "</table></pre>\n";

	print b('command:');
	print '<br>';
	print em('ntpq -c rv', $host);

	open(NTPQ_rv, "ntpq.dns -c rv $host |");

	print "\n<pre><table border=1>\n";
	while (<NTPQ_rv>) {
		chomp;
		@rv = split(/=/, $_);
		$ll = td({-align=>LEFT}, [$rv[0]]);
		$lr = td({-align=>RIGHT}, [$rv[1]]);
		print Tr(["$ll $lr"]);
		print "\n";
	}
	print "\n</table></pre>\n";
}

print end_html;
